import md5 from 'blueimp-md5'
import { fetchEventSource } from '@microsoft/fetch-event-source'
import { fetchAgents } from '@/api/chat'

export function useChat() {
  const authKey = 'f3846153ba784b6d86bdcd5533259c88'
  const authSecret = 'HO4IyLEwEOHpeOXBxaLQUOqWslJRGs1M'

  const messages = ref([])

  async function post(data) {
    const timestamp = Date.now()
    const sign = md5(`${authKey}${authSecret}${timestamp}`)
    await fetchEventSource('/openapi/agent/chat/stream/v1', {
      method: 'POST',
      headers: { authKey, timestamp, sign, 'Content-Type': 'application/json' },
      body: JSON.stringify(data),
      onmessage(res) {
        console.log(res.data)
        const message = JSON.parse(res.data)
        const conversationId = message.conversationId
        const messageId = messages.value.findIndex(session => session.conversationId === conversationId)
        if (messageId === -1) {
          messages.value.push({ conversationId, role: 'bot', content: message.content })
        } else {
          messages.value[messageId].content + message.content
        }
      }
    })
  }

  async function getAgents() {
    await fetchAgents()
  }

  return { messages, post, getAgents }
}
